// --------------
// DLLInterface.h
// --------------

#ifndef __DLLINTERFACE_H__
#define __DLLINTERFACE_H__

// Can't believe vc doesn't automate this kind of stuff
#ifdef __DO_DLL_EXPORT__
#define __DLL_FUNCTION__ __declspec(dllexport)
#else
#define __DLL_FUNCTION__ __declspec(dllimport)
#endif

// Interface that the app provides to the DLL
class IAppInterface
{
public:
  virtual int Operation(int parm) = 0;
  // ...
};

// Interface that the DLL provides to the app;
class IDLLInterface
{
public:
  virtual void MyDLLFunction(int parm) = 0;
  // ...
};

extern "C" __DLL_FUNCTION__ IDLLInterface *CreateDLLInterface(IAppInterface *pApp);
typedef IDLLInterface *(*FuncCreateDLLInterface) (IAppInterface *pApp);

#endif //__DLLINTERFACE_H__
